package peermgr

import (
	"github.com/libp2p/go-libp2p-core/peer"
	"github.com/link33/sidecar/internal/port"
	"github.com/link33/sidecar/internal/router"
	"github.com/link33/sidecar/model/pb"
	"github.com/meshplus/bitxhub-kit/crypto"
	"github.com/sirupsen/logrus"
)

type local struct {
	id      peer.ID
	privKey crypto.PrivateKey
	tag     string
	rev     chan *pb.Message
	rout    router.Router
	logger  logrus.FieldLogger
}

func (l *local) ID() string {
	return l.id.String()
}

func (l *local) Type() string {
	return port.Sidecar
}

func (l *local) Name() string {
	return l.ID()
}

func (l *local) Tag() string {
	return l.tag
}

func (l *local) Send(msg *pb.Message) (*pb.Message, error) {
	panic("implement me")
}

func (l *local) AsyncSend(msg *pb.Message) error {
	// 目标to == id 本机，获取信息
	// 转发给路由器的。
	// 判断数据类型
	var to = ""
	if to == l.id.String() {
		//获取本机信息,以及本机做的工作。

	} else {
		//转发给路由模块
		//l.rout.Route()
		l.rev <- msg
	}
	return nil
	//panic("implement me")
}

func (l *local) ListenIBTPX() <-chan *pb.Message {
	return l.rev
}

// sidecar 节点
func (l *local) HandleGetPeerInfoMessage(p port.Port, message *pb.Message) {
	data := &pb.PeerInfo{
		ID:  l.ID(),
		Tag: l.Tag(),
	}
	msg, _ := data.Marshal()
	retMsg := pb.Msg(pb.Message_ACK, true, msg)
	err := p.AsyncSend(retMsg)
	if err != nil {
		l.logger.Error(err)
	}
}
